<template>
  <div>
    <add-document-dialog
      :key="dialogDocumentKey"
      v-model="dialogAddDocument"
      :id-appointment-detail="this.detailAppointment.idAppointmentDetail"
      @refresh="getAppointmentDetails()"
    />
    <alert-action
      :key="dialogAlertKey"
      v-model="dialogAlert"
      :id-appointment="this.$route.params.id"
      message="¿Está seguro que desea cancelar la cita?"
      @refresh="getAppointmentDetails()"
    />
    <v-row id="AppointmentDetails">
      <v-col v-if="detailAppointment.appointment">
        <v-container>
          <div class="text-h3">
            {{ title }}
          </div>
        </v-container>
        <v-container>
          <div class="d-flex justify-space-between">
            <div class="text-h5">Información de la cita</div>
            <div class="d-flex align-center">
              <div class="mr-2">Estado:</div>
              <v-chip
                v-if="detailAppointment.appointment"
                :color="this.getColorChip(detailAppointment.appointment.state)"
                depressed
                text-color="white"
                class="font-weight-bold"
              >
                {{ getNameState(detailAppointment.appointment.state) }}
              </v-chip>
            </div>
          </div>
        </v-container>
        <details-card>
          <div class="d-flex justify-space-between px-5 mb-5">
            <v-card-title v-if="detailAppointment.appointment" class="pa-0">
              {{ formatDate(detailAppointment.appointment.startTime) }}
            </v-card-title>
            <v-btn
              v-if="detailAppointment.appointment"
              depressed
              color="primary"
              rounded
              large
              style="padding: 15px"
              :disabled="
                !availabilityVideocalling(
                  detailAppointment.appointment.startTime,
                  detailAppointment.appointment.endTime,
                  detailAppointment.appointment.state
                )
              "
              @click="joinVideocall"
            >
              UNIRSE A LA LLAMADA
            </v-btn>
          </div>
          <div class="d-flex justify-space-between px-5">
            <v-card-title v-if="detailAppointment.appointment" class="pa-0">
              {{
                formatHour(
                  detailAppointment.appointment.startTime,
                  detailAppointment.appointment.endTime
                )
              }}
            </v-card-title>
            <v-btn
              v-if="detailAppointment.appointment"
              depressed
              large
              rounded
              color="primary"
              style="padding: 15px"
              :disabled="
                disabledAppointment(
                  detailAppointment.appointment.isCancellable,
                  detailAppointment.appointment.state
                )
              "
              @click="cancelAppointment"
            >
              CANCELAR CITA
            </v-btn>
          </div>
        </details-card>
        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">Recursos de la cita</div>
            </v-col>
          </v-row>
        </v-container>
        <v-container>
          <v-tabs color="primary">
            <v-tab v-if="detailAppointment.appointment">
              {{
                "Enlaces " +
                "(" +
                detailAppointment.specialistResources.linkResources.length +
                ")"
              }}
            </v-tab>
            <v-tab v-if="detailAppointment.appointment">
              {{
                "Documentos " +
                "(" +
                detailAppointment.specialistResources.documentResources.length +
                ")"
              }}
            </v-tab>

            <v-tab-item v-for="n in 2" :key="n">
              <details-card>
                <v-col v-if="n == 1">
                  <div
                    v-if="
                      detailAppointment.specialistResources.linkResources
                        .length > 0
                    "
                  >
                    <div
                      v-for="(link, index) in detailAppointment
                        .specialistResources.linkResources"
                      :key="index"
                    >
                      <v-row>
                        <v-col md="3">
                          <v-card-title>{{ link.name + ":" }}</v-card-title>
                        </v-col>
                        <v-col md="8">
                          <v-text-field outlined :value="link.url" readonly>
                            <template #append>
                              <a :href="link.url" target="_blank">
                                <v-icon> mdi-open-in-new </v-icon>
                              </a>
                            </template>
                          </v-text-field>
                        </v-col>
                      </v-row>
                    </div>
                  </div>
                  <div v-else>
                    <v-card-title> No hay enlaces registrados </v-card-title>
                  </div>
                </v-col>
                <v-col v-else>
                  <div
                    v-if="
                      detailAppointment.specialistResources.documentResources
                        .length > 0
                    "
                  >
                    <div
                      v-for="(document, index) in detailAppointment
                        .specialistResources.documentResources"
                      :key="index"
                    >
                      <v-row>
                        <v-col md="11">
                          <v-text-field
                            outlined
                            :value="document.name"
                            readonly
                          >
                            <template #append>
                              <a :href="document.url" target="_blank">
                                <v-icon color="primary">
                                  mdi-cloud-download
                                </v-icon>
                              </a>
                            </template>
                          </v-text-field>
                        </v-col>
                      </v-row>
                    </div>
                  </div>
                  <div v-else>
                    <v-card-title> No hay documentos registrados </v-card-title>
                  </div>
                </v-col>
              </details-card>
            </v-tab-item>
          </v-tabs>
        </v-container>
        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">Mis recursos</div>
            </v-col>
          </v-row>
        </v-container>
        <v-container>
          <v-tabs color="primary">
            <v-tab v-if="detailAppointment.appointment">
              {{
                "Documentos " +
                "(" +
                detailAppointment.patientResources.documentResources.length +
                ")"
              }}
            </v-tab>
            <v-tab-item v-for="n in 2" :key="n">
              <details-card>
                <v-col v-if="n == 1">
                  <div
                    v-if="
                      detailAppointment.patientResources.documentResources
                        .length > 0
                    "
                  >
                    <div
                      v-for="(document, index) in detailAppointment
                        .patientResources.documentResources"
                      :key="index"
                    >
                      <v-row>
                        <v-col md="11">
                          <v-text-field
                            outlined
                            :value="document.name"
                            readonly
                          >
                            <template #append>
                              <a :href="document.url" target="_blank">
                                <v-icon color="primary">
                                  mdi-cloud-download
                                </v-icon>
                              </a>
                              <v-icon>mdi-delete</v-icon>
                            </template>
                          </v-text-field>
                        </v-col>
                      </v-row>
                    </div>
                  </div>
                  <div v-else>
                    <v-card-title> No hay documentos registrados </v-card-title>
                  </div>
                  <v-row>
                    <v-col md="10" />
                    <v-col md="2">
                      <v-btn
                        depressed
                        large
                        rounded
                        color="primary"
                        style="padding: 15px"
                        outlined
                        @click="addDocumentInDetail"
                      >
                        Agregar
                      </v-btn>
                    </v-col>
                  </v-row>
                </v-col>
              </details-card>
            </v-tab-item>
          </v-tabs>
        </v-container>
        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">Información del especialista</div>
            </v-col>
          </v-row>
        </v-container>
        <details-card>
          <v-row class="v-container-info-specialist" align="center">
            <v-col md="2" align="center">
              <ImagePhoto :photo="detailAppointment.appointment.specialist.profileImageUrl" size="100"/>
            </v-col>
            <v-col md="6">
              <h2
                v-if="detailAppointment.appointment"
                class="font-weight-black"
              >
                {{
                  detailAppointment.appointment.specialist.name +
                  " " +
                  detailAppointment.appointment.specialist.fatherLastname +
                  " " +
                  detailAppointment.appointment.specialist.motherLastname
                }}
              </h2>
              <h3
                v-if="detailAppointment.appointment"
                class="font-weight-regular"
              >
                {{
                  "Correo: " + detailAppointment.appointment.specialist.email
                }}
              </h3>
              <h3
                v-if="detailAppointment.appointment"
                class="font-weight-regular"
              >
                {{
                  "Telefono: " +
                  detailAppointment.appointment.specialist.phoneNumber
                }}
              </h3>
            </v-col>
          </v-row>
        </details-card>
        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">Resultados de la cita</div>
            </v-col>
          </v-row>
        </v-container>
        <details-card>
          <v-container>
            <v-row>
              <v-col md="6">
                <div class="text-h6">Comentarios de la cita</div>
              </v-col>
            </v-row>
          </v-container>
          <v-container>
            <v-row style="padding-right: 35px">
              <v-col>
                <div
                  id="RTE__edition__field"
                  contenteditable="false"
                  :style="{ minHeight: height + 'px', borderColor }"
                >
                  <p
                    v-if="detailAppointment.results"
                    v-html="
                      this.detailAppointment.results.substring(1).slice(0, -1)
                    "
                  />
                </div>
              </v-col>
            </v-row>
          </v-container>
        </details-card>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { formatAMPM } from "~/helpers/time";
import ImagePhoto from "~/components/appointment/ImagePhoto";
import moment from 'moment-timezone';
import DetailsCard from "~/components/Cards/DetailsCard.vue";
import AddDocumentDialogPatient from "~/components/Dialogs/AddDocumentDialogPatient.vue";
import AlertActionPatient from "~/components/Alert/AlertActionPatient.vue";

export default {
  name: "AppointmentDetails",
  components: {
    "details-card": DetailsCard,
    "add-document-dialog": AddDocumentDialogPatient,
    "alert-action": AlertActionPatient,
    ImagePhoto,
  },
  props: {
    borderColor: {
      type: String,
      required: false,
      default: "rgba(0, 0, 0, 0.5)",
    },
    height: {
      type: Number,
      required: false,
      default: 200,
    },
  },
  data() {
    return {
      isCancelable: false,
      accessAppointment: false,
      dialogDocumentKey: 10,
      dialogAlertKey: 50,
      dialogAddDocument: false,
      dialogAlert: false,
      title: "Detalle de Cita",
      days: [
        "Domingo",
        "Lunes",
        "Martes",
        "Miercoles",
        "Jueves",
        "Viernes",
        "Sabado",
      ],
      months: [
        "Enero",
        "Febrero",
        "Marzo",
        "Abril",
        "Mayo",
        "Junio",
        "Julio",
        "Agosto",
        "Septiembre",
        "Octubre",
        "Noviembre",
        "Diciembre",
      ],
    };
  },
  computed: {
    ...mapState({
      appointment: (state) => state.appointments.appointment,
      detailAppointment: (state) =>
        state.specialist.appointments.detailAppointment,
    }),
  },
  mounted() {
    this.getAppointmentDetails();
  },
  methods: {
    ...mapActions({
      getAppointment: "appointments/getAppointment",
      getAgoraName: "videocall/videocalls/getAgoraName",
      getAppointmentDetail: "specialist/appointments/getAppointmentDetail",
    }),
    joinVideocall() {
      this.getAgoraName(this.$route.params.id).then((response) => {
        console.log(response);
        open(
          this.$config.ctVideocallingUrl + "/videocalling/" + response.data,
          "_blank"
        );
      });
    },
    forceRenderDocument() {
      this.dialogDocumentKey += 1;
    },
    forceRenderAlert() {
      this.dialogAlertKey += 1;
    },
    disabledAppointment(isCancelable, state) {
      if (!isCancelable || state === 1) {
        return true;
      }
      return false;
    },
    cancelAppointment() {
      this.forceRenderAlert();
      this.dialogAlert = true;
    },
    availabilityVideocalling(startTime, endTime, state) {
      const date = new Date();
      console.log("FECHA ACTUAL", date.getMonth());
      const dateString =
        date.getFullYear() +
        "-" +
        (date.getMonth() + 1 < 10 ? "0" : "") +
        (date.getMonth() + 1) +
        "-" +
        (date.getDate() < 10 ? "0" : "") +
        date.getDate() +
        "T" +
        (date.getHours() < 10 ? "0" : "") +
        date.getHours() +
        ":" +
        (date.getMinutes() < 10 ? "0" : "") +
        date.getMinutes() +
        ":" +
        (date.getSeconds() < 10 ? "0" : "") +
        date.getSeconds();
      console.log("DATESTRING", dateString);
      console.log("DATESTART", startTime);
      const validateIni = startTime.valueOf() <= dateString.valueOf();
      console.log("VALIDATION INI", validateIni);
      const validateEnd = endTime.valueOf() > dateString.valueOf();
      console.log("VALIDATION END", validateEnd);
      const validateState = state !== 1;
      return validateIni && validateEnd && validateState;
    },
    getColorChip(stateSession) {
      if (stateSession === 0) {
        return "orange";
      }
      if (stateSession === 1) {
        return "red";
      }
      return "primary";
    },
    getNameState(stateSession) {
      if (stateSession === 0) {
        return "PENDIENTE";
      }
      if (stateSession === 1) {
        return "CANCELADA";
      }
      return "FINALIZADO";
    },
    getAppointmentDetails() {
      this.getAppointmentDetail({ idAppointment: this.$route.params.id });
    },
    formatDate(date) {
      if (!date) {
        return null;
      }
      const weekDayName =  moment(date).locale('es').format('dddd');
      const capitalizewd = weekDayName[0].toUpperCase() + weekDayName.slice(1);
      const [year, month, day] = date.split("-");
      const months = [
        "enero",
        "febrero",
        "marzo",
        "abril",
        "mayo",
        "junio",
        "julio",
        "agosto",
        "setiembre",
        "octubre",
        "noviembre",
        "diciembre",
      ];
      const [dayNumber, tail] = day.split("T");
      return `${capitalizewd} ${dayNumber} de ${months[month - 1]} del ${year}`;
    },
    formatHour(hourIni, hourFin) {
      const startHour = formatAMPM(new Date(hourIni))
      const endHour = formatAMPM(new Date(hourFin))
      return `De ${startHour} a ${endHour}`;
    },
    openLink(link) {
      window.open(link, "_blank");
    },
    postDocument({ document1 }) {
      this.dialogAddDocument = false;
    },
    addDocumentInDetail() {
      this.forceRenderDocument();
      this.dialogAddDocument = true;
    },
    twoDigits(number) {
      if (number < 10) {
        return "0" + number;
      } else {
        return number;
      }
    },
  },
};
</script>

<style scoped>
.centered-input >>> textarea {
  text-align: center;
}
.left-input >>> textarea {
  text-align: left;
}
.v-container-info-appointment {
  display: flex;
  align-items: center;
}
.button-start-session {
  padding-bottom: 20px;
}
#RTE__edition__field {
  border: 1px solid;
  padding: 5px;
  border-radius: 20px;
}
</style>
